SystemOrganization addCategory: #ConfigurationOfODBC!

Object subclass: #ConfigurationOfODBC
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfODBC'!

!ConfigurationOfODBC classSide methodsFor: 'private' stamp: 'tbn 1/13/2010 13:11'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfODBC classSide methodsFor: 'private' stamp: 'tbn 1/13/2010 13:11'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfODBC classSide methodsFor: 'metacello tool support' stamp: 'tbn 1/13/2010 13:10'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfODBC classSide methodsFor: 'metacello tool support' stamp: 'tbn 1/13/2010 13:10'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfODBC classSide methodsFor: 'loading' stamp: 'tbn 5/15/2010 17:12'!
load
	^self project latestVersion load! !

!ConfigurationOfODBC classSide methodsFor: 'metacello tool support' stamp: 'tbn 1/13/2010 13:11'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfODBC classSide methodsFor: 'accessing' stamp: 'tbn 1/13/2010 13:10'!
project

	^self new project! !

!ConfigurationOfODBC methodsFor: 'baselines' stamp: 'tbn 11/2/2010 19:57'!
baseline10: spec
    <version: '1.0-baseline'>
    
    spec for: #common do: [
        spec blessing: #baseline.
	  spec description: '1.0 baseline for ODBC'.
        spec repository: 'http://www.squeaksource.com/ODBC'.      
        spec package: 'ODBC'
		     with: [ spec requires: #('FFI' ) ].
	  spec
			project: 'FFI' with: [
				spec
					className: 'ConfigurationOfFFI';
					file: 'ConfigurationOfFFI';					 
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
    ]
      
        
! !

!ConfigurationOfODBC methodsFor: 'accessing' stamp: 'tbn 1/13/2010 13:05'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfODBC methodsFor: 'versions' stamp: 'tbn 11/2/2010 19:59'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec description: 'initial configuration'. 
		spec author: 'Torsten Bergmann'.
		spec timestamp: '11/2/2010 10:12'.
		spec 
			project: 'FFI' with: '1.3'.	 
		spec package: 'ODBC' with: 'ODBC-fap.11'.
	]! !
